# Hey emacs! This is a -*- Perl -*- script!
# read_pkglist.pl -- Perl utility functions to read Lintian's package lists

sub read_src_list {
  return if %source_info;

  my $src_list = "$LINTIAN_LAB/info/source-packages";
  return unless -f $src_list;

  open(IN,$src_list) or fail("cannot open source list file $src_list: $!");
  while (<IN>) {
    chop;
    next if /^\s*$/o;
    my ($src,$ver,$maint,$arch,$std,$bin,$files,$file) = split(/\;/,$_);

    my $src_struct;
    %$src_struct = (
		    'source' => $src,
		    'version' => $ver,
		    'maintainer' => $maint,
		    'architecture' => $arch,
		    'standards-version' => $std,
		    'binary' => $bin,
		    'files' => $files,
		    'file' => $file,
		   );
  
    $source_info{$src} = $src_struct;
  }
  close(IN);
}

sub read_bin_list {
  return if %binary_info;

  my $bin_list = "$LINTIAN_LAB/info/binary-packages";
  return unless -f $bin_list;

  open(IN,$bin_list) or fail("cannot open binary list file $bin_list: $!");
  while (<IN>) {
    chop;
    next if /^\s*$/o;
    my ($bin,$ver,$source,$file) = split(/\;/,$_);

    my $bin_struct;
    %$bin_struct = (
		    'package' => $bin,
		    'version' => $ver,
		    'source' => $source,
		    'file' => $file,
		   );
  
    $binary_info{$bin} = $bin_struct;
  }
  close(IN);
}

sub get_bin_src_ref {
  read_src_list();
  for $source (keys %source_info) {
    for $binary (split(/,\s+/o,$source_info{$source}->{'binary'})) {
      $bin_src_ref{$binary} = $source;
    }
  }
}

1;
